<template>
  <div class="container">
    <the-table
      :is-data-loading="isDataLoading"
      :data="entries"
      :columns="columns"
      @toggle-column="toggleColumn"
    />
  </div>
</template>

<script setup>
import TheTable from './components/TheTable/TheTable.vue'
import BooleanCell from './components/TheTable/components/BooleanCell.vue'
import CorsCell from './components/TheTable/components/CorsCell.vue'
import LinkCell from './components/TheTable/components/LinkCell.vue'
import { onMounted, ref, shallowRef } from 'vue'
import { v4 as uuidv4 } from 'uuid';
import { api } from './api/api.js'

const entries = ref([])
const columns = ref([
  { id: uuidv4(), title: 'Назва АПІ', key: 'API', showColumn: true },
  { id: uuidv4(), title: 'Опис', key: 'Description', showColumn: true },
  { id: uuidv4(), title: 'Тип авторизації', key: 'Auth', showColumn: true },
  { id: uuidv4(), title: 'HTTPS', key: 'HTTPS', showColumn: true, component: shallowRef(BooleanCell) },
  { id: uuidv4(), title: 'Cors', key: 'Cors', showColumn: true, component: shallowRef(CorsCell) },
  { id: uuidv4(), title: 'Категорія', key: 'Category', showColumn: true },
  { id: uuidv4(), title: 'Посилання', key: 'Link', showColumn: true, component: shallowRef(LinkCell) },
])
const isDataLoading = ref(true)

function toggleColumn(columnId) {
  const column = columns.value.find(column => column.id === columnId)
  column.showColumn = !column.showColumn
}

async function loadEntries() {
  isDataLoading.value = true
  const {data} = await api.entries.getAll()
  
  entries.value = data.entries.slice(0, 100).map(entry => ({
    ...entry,
    uniqueId: uuidv4()
  }))
  
  isDataLoading.value = false
}

onMounted(() => {
  loadEntries()
})

</script>

<style>

</style>
